# This file was created automatically by SWIG.
import pypropertywrapperc
from oof2.SWIG.engine.properties import PropertyPtr
from oof2.SWIG.engine.element import ElementDataPtr
class PyPropertyWrapperPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,pypropertywrapperc=pypropertywrapperc):
        if self.thisown == 1 :
            pypropertywrapperc.delete_PyPropertyWrapper(self)
    def __repr__(self):
        return "<C PyPropertyWrapper instance at %s>" % (self.this,)
class PyPropertyWrapper(PyPropertyWrapperPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(pypropertywrapperc.new_PyPropertyWrapper,_args,_kwargs)
        self.thisown = 1




class PyPropertyElementDataPtr(ElementDataPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def data(self, *_args, **_kwargs):
        val = apply(pypropertywrapperc.PyPropertyElementData_data,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C PyPropertyElementData instance at %s>" % (self.this,)
class PyPropertyElementData(PyPropertyElementDataPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(pypropertywrapperc.new_PyPropertyElementData,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: pypropertywrapper.spy,v $
# $Revision: 1.5 $
# $Author: langer $
# $Date: 2006/01/11 22:30:55 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# These are the Pythonized wrappers for the virtual functions
# of the Property class, as seen from Python.  They are called
# back from the C++ PyPropertyWrapper class, and in turn call
# the corresponding methods of the derived pure-Python
# property.  Their primary function is to wrap their arguments
# in <whatever>Ptr constructors, so all the SWIG'd methods
# are available in the derived-class routine.

from oof2.common import debug
from oof2.SWIG.engine import element

# These defs could be done by pragma's in the SWIG file, but
# having all the names be local is good.
from oof2.SWIG.engine import femesh
FEMeshPtr = femesh.FEMeshPtr
from oof2.SWIG.engine import elementnodeiterator
ElementFuncNodeIteratorPtr = elementnodeiterator.ElementFuncNodeIteratorPtr
from oof2.SWIG.engine import mastercoord
MasterPositionPtr = mastercoord.MasterPositionPtr
from oof2.SWIG.engine import flux
FluxPtr = flux.FluxPtr
FluxDataPtr = flux.FluxDataPtr
from oof2.SWIG.engine import material
MaterialPtr = material.MaterialPtr

def _PyPropertyWrapper_precomputewrap(self):
    if hasattr(self,'precompute'):
        self.precompute()

PyPropertyWrapperPtr.precomputewrap = _PyPropertyWrapper_precomputewrap

def _PyPropertyWrapper_cross_referencewrap(self, material_p):
    if hasattr(self,'cross_reference'):
        material = MaterialPtr(material_p)
        self.cross_reference(material)

PyPropertyWrapperPtr.cross_referencewrap = _PyPropertyWrapper_cross_referencewrap


def _PyPropertyWrapper_begin_elementwrap(self, element_p):
    if hasattr(self,'begin_element'):
        elmnt = element.ElementPtr(element_p)
        self.begin_element(elmnt)

PyPropertyWrapperPtr.begin_elementwrap = _PyPropertyWrapper_begin_elementwrap


def _PyPropertyWrapper_end_elementwrap(self, element_p):
    if hasattr(self,'end_element'):
        elmnt = element.ElementPtr(element_p)
        self.end_element(elmnt)

PyPropertyWrapperPtr.end_elementwrap = _PyPropertyWrapper_end_elementwrap


def _PyPropertyWrapper_post_processwrap(self, mesh_p, element_p):
    if hasattr(self,'post_process'):
        mesh = FEMeshPtr(mesh_p)
        elmnt = element.ElementPtr(element_p)
        self.post_process(mesh, elmnt)

PyPropertyWrapperPtr.post_processwrap = _PyPropertyWrapper_post_processwrap


def _PyPropertyWrapper_fluxmatrixwrap(self, mesh_p, element_p,
                                      efni_p, flux_p, fluxdata_p, masterpos_p):
    if hasattr(self,'fluxmatrix'):
        mesh = FEMeshPtr(mesh_p)
        elmnt = element.ElementPtr(element_p)
        efni = ElementFuncNodeIteratorPtr(efni_p)
        flux = FluxPtr(flux_p)
        fluxdata = FluxDataPtr(fluxdata_p)
        masterpos = MasterPositionPtr(masterpos_p)
        self.fluxmatrix(mesh, elmnt, efni, flux, fluxdata, masterpos)
        
PyPropertyWrapperPtr.fluxmatrixwrap = _PyPropertyWrapper_fluxmatrixwrap

    
def _PyPropertyWrapper_fluxrhswrap(self, mesh_p, element_p,
                                  flux_p, fluxdata_p, masterpos_p):
    if hasattr(self,'fluxrhs'):
        mesh = FEMeshPtr(mesh_p)
        elmnt = element.ElementPtr(element_p)
        flux = FluxPtr(flux_p)
        fluxdata = FluxDataPtr(fluxdata_p)
        masterpos = MasterPositionPtr(masterpos_p)
        self.fluxrhs(mesh, elmnt, flux, fluxdata, masterpos)

PyPropertyWrapperPtr.fluxrhswrap = _PyPropertyWrapper_fluxrhswrap

# Utility functions to support storing data in an element.
def _PyPropertyWrapper_data_to_element(self, element, name, data):
    pass

# Sensible display string for element data.
def _PyPropertyElementData___repr__(self):
    return "PyPropertyElementData(%s,%s)" % (self.name(), `self.data()`)

PyPropertyElementDataPtr.__repr__ = _PyPropertyElementData___repr__
