// -*- C++ -*-
// $RCSfile: celectricfield.h,v $
// $Revision: 1.2 $
// $Author: redwing $
// $Date: 2005/03/03 18:26:35 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#ifndef CELECTRICFIELD_H
#define CELECTRICFIELD_H

class Element;
class FEMesh;
class MasterPosition;
class Field;

#include "engine/matvec.h"
#include "engine/IO/propertyoutput.h"

void findElectricField(const FEMesh *, const Element *,
		       const MasterPosition &, VECTOR_D &);



#endif // CELECTRICFIELD_H
