# This file was created automatically by SWIG.
import euleranglec
class EulerAnglePtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def alpha(self, *_args, **_kwargs):
        val = apply(euleranglec.EulerAngle_alpha,(self,) + _args, _kwargs)
        return val
    def beta(self, *_args, **_kwargs):
        val = apply(euleranglec.EulerAngle_beta,(self,) + _args, _kwargs)
        return val
    def gamma(self, *_args, **_kwargs):
        val = apply(euleranglec.EulerAngle_gamma,(self,) + _args, _kwargs)
        return val
    def __neg__(self, *_args, **_kwargs):
        val = apply(euleranglec.EulerAngle___neg__,(self,) + _args, _kwargs)
        if val: val = EulerAnglePtr(val) ; val.thisown = 1
        return val
    def set(self, *_args, **_kwargs):
        val = apply(euleranglec.EulerAngle_set,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C EulerAngle instance at %s>" % (self.this,)
class EulerAngle(EulerAnglePtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(euleranglec.new_EulerAngle,_args,_kwargs)
        self.thisown = 1



def EulerAngle_void(*_args,**_kwargs):
    val = EulerAnglePtr(apply(euleranglec.new_EulerAngle_void,_args,_kwargs))
    val.thisown = 1
    return val

def EulerAngle_SphereCoord(*_args,**_kwargs):
    val = EulerAnglePtr(apply(euleranglec.new_EulerAngle_SphereCoord,_args,_kwargs))
    val.thisown = 1
    return val


class SphereCoordPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __neg__(self, *_args, **_kwargs):
        val = apply(euleranglec.SphereCoord___neg__,(self,) + _args, _kwargs)
        if val: val = EulerAnglePtr(val) ; val.thisown = 1
        return val
    def __repr__(self):
        return "<C SphereCoord instance at %s>" % (self.this,)
class SphereCoord(SphereCoordPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(euleranglec.new_SphereCoord,_args,_kwargs)
        self.thisown = 1



def SphereCoord_void(*_args,**_kwargs):
    val = SphereCoordPtr(apply(euleranglec.new_SphereCoord_void,_args,_kwargs))
    val.thisown = 1
    return val




#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: eulerangle.spy,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2005/10/18 17:31:24 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

#import sys
#EulerAngle    = sys.modules['oofswg'].EulerAngle

# We're going to overload the constructor and call the appropriate C++
# constructor depending on our arguments
def _EulerAngle___init__(self,*_args,**_kwargs):
    self.thisown = 1
    nargs = len(_args)+len(_kwargs)
    if(nargs == 0):
        self.this = apply(euleranglec.new_EulerAngle_void,_args,_kwargs)
    elif(nargs == 1):
        self.this = apply(euleranglec.new_EulerAngle_SphereCoord,_args,_kwargs)
    elif(nargs == 3):
        self.this = apply(euleranglec.new_EulerAngle,_args,_kwargs)
    else:
        raise TypeError("Bad arguments for EulerAngle")

EulerAngle.__init__ = _EulerAngle___init__

EulerAnglePtr.__repr__ = lambda self:"EulerAngle(%.99g, %.99g, %.99g)" \
                         % (self.alpha(), self.beta(), self.gamma())


# Make this class available in the restricted namespace.
from oof2.common import utils
utils.OOFdefine('EulerAngle', EulerAngle)
